/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/*
 * This code has been autogenerated, do not edit
 */

#include <stdio.h>

#include "ArtNetConfParser.h"
#include "ArtNetConfMsg.h"

#include "ArtNetConfMsgPortReq.h"
#include "ArtNetConfMsgPrmRep.h"

ArtNetConfParser::ArtNetConfParser() {}
ArtNetConfParser::~ArtNetConfParser() {}


/*
 * Pass the buffer and return a Message object
 * @param data  the data representing the serialized object
 * @param len	the length of the data
 */
ArtNetConfMsg *ArtNetConfParser::parse(const uint8_t *data, int len) {
  lla_artnet_conf_msg *req = (lla_artnet_conf_msg *) data;

  if(len < lla_artnet_conf_header_size)
    return NULL;

   
  if ( req->plugid != 2)
    return NULL;
  
  switch(req->op) {
    case LLA_ARTNET_CONF_MSG_PORT_REQ:
      return parse_port_req(req, len);
    case LLA_ARTNET_CONF_MSG_PRM_REP:
      return parse_prm_rep(req, len);
    default:
      return NULL;
  }
}


/*
 * Parses a port request message
 *
 * @param req	the request buffer
 * @param len 	the buffer length
 */
ArtNetConfMsg *ArtNetConfParser::parse_port_req(lla_artnet_conf_msg *req, int len) {
	
  if( len != sizeof(lla_artnet_conf_msg_port_req) + lla_artnet_conf_header_size)
    return NULL;

  ArtNetConfMsgPortReq *m = new ArtNetConfMsgPortReq();

  return m;
}


/*
 * Parses a port reply message
 *
 * @param req	the request buffer
 * @param len 	the buffer length
 */
ArtNetConfMsg *ArtNetConfParser::parse_prm_rep(lla_artnet_conf_msg *req, int len) {
	
  if( len != sizeof(lla_artnet_conf_msg_prm_rep) + lla_artnet_conf_header_size)
    return NULL;

  ArtNetConfMsgPrmRep *m = new ArtNetConfMsgPrmRep();

  return m;
}

