/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/*
 * This code has been autogenerated, do not edit
 */

#ifndef LLA_USBPRO_CONF_MESSAGES_H
#define LLA_USBPRO_CONF_MESSAGES_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>

/*
 * opcodes
 */
enum lla_usbpro_conf_msg_op_e {
  LLA_USBPRO_CONF_MSG_PRM_REQ = 0x01,    // param request
  LLA_USBPRO_CONF_MSG_PRM_REP = 0x02,    // param reply
  LLA_USBPRO_CONF_MSG_SPRM_REQ = 0x03,    // set param request
  LLA_USBPRO_CONF_MSG_SPRM_REP = 0x04,    // set param reply
  LLA_USBPRO_CONF_MSG_SER_REQ = 0x05,    // serial number request
  LLA_USBPRO_CONF_MSG_SER_REP = 0x06,    // serial number reply
};

typedef enum lla_usbpro_conf_msg_op_e lla_usbpro_conf_msg_op;


/*
 * param request struct 
 */
struct lla_usbpro_conf_msg_prm_req_s {
} __attribute__( ( packed ) );

typedef struct lla_usbpro_conf_msg_prm_req_s lla_usbpro_conf_msg_prm_req;


/*
 * param reply struct 
 */
struct lla_usbpro_conf_msg_prm_rep_s {
  uint16_t firmware;
  uint8_t brk;
  uint8_t mab;
  uint8_t rate;
} __attribute__( ( packed ) );

typedef struct lla_usbpro_conf_msg_prm_rep_s lla_usbpro_conf_msg_prm_rep;


/*
 * set param request struct 
 */
struct lla_usbpro_conf_msg_sprm_req_s {
  uint8_t brk;
  uint8_t mab;
  uint8_t rate;
} __attribute__( ( packed ) );

typedef struct lla_usbpro_conf_msg_sprm_req_s lla_usbpro_conf_msg_sprm_req;


/*
 * set param reply struct 
 */
struct lla_usbpro_conf_msg_sprm_rep_s {
  uint8_t status;
} __attribute__( ( packed ) );

typedef struct lla_usbpro_conf_msg_sprm_rep_s lla_usbpro_conf_msg_sprm_rep;


/*
 * serial number request struct 
 */
struct lla_usbpro_conf_msg_ser_req_s {
} __attribute__( ( packed ) );

typedef struct lla_usbpro_conf_msg_ser_req_s lla_usbpro_conf_msg_ser_req;


/*
 * serial number reply struct 
 */
struct lla_usbpro_conf_msg_ser_rep_s {
  uint8_t status;
  uint8_t serial[4];
} __attribute__( ( packed ) );

typedef struct lla_usbpro_conf_msg_ser_rep_s lla_usbpro_conf_msg_ser_rep;


/*
 * union of all the msgs
 */
union lla_usbpro_conf_msg_u {
    lla_usbpro_conf_msg_prm_req prm_req;
    lla_usbpro_conf_msg_prm_rep prm_rep;
    lla_usbpro_conf_msg_sprm_req sprm_req;
    lla_usbpro_conf_msg_sprm_rep sprm_rep;
    lla_usbpro_conf_msg_ser_req ser_req;
    lla_usbpro_conf_msg_ser_rep ser_rep;
};


struct lla_usbpro_conf_msg_s {
  uint8_t op;
  uint16_t plugid;	// 5
  union lla_usbpro_conf_msg_u data;
};

typedef struct lla_usbpro_conf_msg_s lla_usbpro_conf_msg;

const int lla_usbpro_conf_header_size = sizeof(lla_usbpro_conf_msg) - sizeof(union lla_usbpro_conf_msg_u);
#ifdef __cplusplus
}
#endif

#endif
